/** 
 * SMARTS cognitive science programming project
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;

public class Mover extends Effector {
    
  public static final int
    MOVE1 = 0,
    MOVE2 = 1,
    MOVE3 = 2;
    
  public static final String[]
    ACTIONS = {"Move 1", "Move 2", "Move 3"};
    
  /**
  * This constructor just sets the UI and the number of
  * actions.   
  */
  Mover (UI ui, Critter critter, int nActions) {
    super(ui, critter, nActions);
  } // constructor Mover

  // Access methods.
  
  public String getActionName (int index)  {
      return ACTIONS[index];
  } // method getActionName(int)
  
  public void attempt(int index) {
      ui.write("Mover attempting " + getActionName(index), 1);
      switch (index) {
	case MOVE1:
	  critter.move(1);
	  break;
	case MOVE2:
	  critter.move(2);
	  break;
	case MOVE3:
	  critter.move(3);
	  break;
	default:
	  ui.write ("Mover doesn't know how to do " + index);
      }
  } // method attempt(int)

} // class Mover
