/** 
 * SMARTS cognitive science programming project
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;
import java.awt.Color;
import java.awt.Graphics;

abstract class Sensor {

  protected int nStates;
    
  protected UI ui;
  
  protected int
    length;
    
  protected int
    displayLength;
    
  protected int
    species;
  
  /**
  * This constructor sets the UI and the Critter.
  */
  Sensor (UI ui, int species) {
    this.ui = ui;
    this.species = species;
    setDisplayLength();
  } // constructor Sensor

  // Access methods.
  
  public int getNStates() {
      return nStates;
  } // method getNStateTypes
  
  public int getLength() {
      return length;
  } // method getLength
  
  public Species getSpecies() {
      return Params.getSpecies(species);
  } // getSpecies()
  
  public int getDisplayLength() {
      return displayLength;
  } // getDisplayLength()
  
  public abstract int getUnitsPerPosition();
  
  protected abstract void setDisplayLength();
  
  // The real work
  
  public abstract int[] sense(Cell cell, int direction);
  // method sense(Cell, int)
  
  public void paint(Graphics g, int x0, int y, int w, int h) {
      int i;
      int x;
      
      for (i = 0, x = x0; i < displayLength; i++, x += w) {
          clear(g, x, y, w, h);
          g.setColor(getDisplayColor(i));
          paint(g, i, x, y, w, h);
      }
  } // method paint
  
  protected abstract void clear(Graphics g, int x, int y, int w, int h);

  protected abstract Color getDisplayColor(int i);
  
  protected abstract Color getColor(int slot);
  
  protected abstract void paint(Graphics g, int i, int x, int y, int w, int h);
  
} // class Sensor
