/** 
 * Smarts
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;

/** Tokenizer which accepts input from an InputReader, permits
* "//" comments, and does the right thing when keywords are
* expected.
*/

public class Tokenizer extends StreamTokenizer {

  Tokenizer (Reader r) {
    super (r);
  } // constructor Tokenizer

  Tokenizer (InputStream st) {
    super (new BufferedReader (new InputStreamReader (st)) );
    this.slashSlashComments (true);
  } // constructor Tokenizer

  public String getKeyword() throws IOException {
    String s = null;
    try {
      nextToken();
      if (ttype == TT_NUMBER)
        // Wrong type of thing; put it back
        pushBack();
      else if (ttype != TT_EOF)
        s = sval;
    } catch (IOException e) {
      System.err.println ("getKeyword: " + e);
    }
    return (s);
  } // method getKeyword

} // class Tokenizer